#include <iostream>
using namespace std;

int t[33][33]; // T matrix
int a[1025][1025]; // Linear system
int m0, n0, m, n;

int nom(int i, int j)
{ return (i-1)*n0 + j; }

int main()
{  cin >> m0 >> n0;  
   for(int i=1; i<=m0; i++)
     for(int j=1; j<=n0; j++)
       cin >> t[i][j];
   
   for(int i=1; i<=m0; i++)
     for(int j=1; j<=n0; j++)
     { int k = nom(i,j);
       if(i>1)  a[k][nom(i-1,j)]=1;
       if(i<m0) a[k][nom(i+1,j)]=1;
       if(j>1)  a[k][nom(i,j-1)]=1;
       if(j<n0) a[k][nom(i,j+1)]=1;
       a[k][0] = t[i][j];
     }  
   
   m = n = m0*n0;
   int cnt = 1;    
   for(int r = 1; r<=m; r++)
   { int c=1; 
     while(c<=n && a[r][c]==0) c++;
     if(c<=n)
     { // a[r][c] - pivot element
       for(int i=r+1; i<=m; i++)    // Gauss elimination
         if(a[i][c]!=0)
         { int k = 1;
           if(a[r][c] == a[i][c]) k = 2;
           for(int j=0; j<=n; j++)
             a[i][j] = (a[i][j] + a[r][j]*k)%3;
         }
     } 
     else 
       if(a[r][0] == 0) cnt = cnt * 3 % 333333;
       else 
          { cout << 0 << endl; // No solution    
            return 0;
          }  
   }
   
   cout << cnt << endl;
   
   return 0;
}
